//+------------------------------------------------------------------+
//|                                   #MTF_BuySell_n_TRend_v_1_6.mq4 |
//|                                                       ServerUang |
//|                                    http://www.indofx-trader.net/ |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                      #MPrice.mq4 |
//|                                           Edited  2008, masemus |
//|                                            Delete SiGNAL / TRend |
//+------------------------------------------------------------------+

#property copyright "ServerUang"
#property link      "http://www.indofx-trader.net/"

#property indicator_chart_window

extern bool Right_Top = true;
extern int Shift_UP_DN = 0; 
extern int Shift_Left_Right = 0;

extern color Info_Color    = SlateGray;
extern color Pips_Up_Color = LightSkyBlue;
extern color Pips_Dn_Color = LightPink;
extern color Hi_Low_Color = White;
extern color Daily_Av_Up_Color = DodgerBlue;
extern color Daily_Av_Dn_Color = DeepPink;

//*****************************************************************************************

string NamaFont, teks;
double nilai, d_A, d_B, d_C;
double High_Lama, Low_Lama;
color  WarnaTeks, WarnaSinyal, WarnaHarga;
int    UkuranFont, pos_x, pos_y, jarak_baris;

// --- variabel Daili_Av --------------------------------------------
int    R1, R5, R10, R20, RAvg, i;
string Teks_ReRata = "", Teks_Rerata_Kemarin ="";
color  warna_ReRata;
// ------------------------------------------------------------------

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int    counted_bars=IndicatorCounted();
//----
   double MA1_M15 = iMA(Symbol(),15,1,0,0,0,0);
   double MA2_M15 = iMA(Symbol(),15,4,0,0,0,0);
   double MA3_M15 = iMA(Symbol(),15,20,0,0,0,0);

   string BS_m5 = "", BS_m15 = "";
   color  cOlr_signal, cOlr_m15;

   if ((MA1_M15 < MA2_M15) && (MA1_M15 < MA3_M15)) { BS_m15 = "-"; cOlr_m15 = DeepPink;}
   if ((MA1_M15 <= MA2_M15) && (MA1_M15 >= MA3_M15)) { BS_m15 = "-"; cOlr_m15 = LightPink;}
   if ((MA1_M15 >= MA2_M15) && (MA1_M15 <= MA3_M15)) { BS_m15 = "-"; cOlr_m15 = LightSkyBlue;}
   if ((MA1_M15 > MA2_M15) && (MA1_M15 > MA3_M15)) { BS_m15 = "-"; cOlr_m15 = DodgerBlue; }


    NamaFont="Arial";
    pos_x=64+Shift_Left_Right; pos_y=50+(13*7)+Shift_UP_DN; 
    Tulis("T11", Right_Top, pos_x+2, pos_y, "Spread", 10, NamaFont, Info_Color);
    
    pos_x=65+Shift_Left_Right; pos_y=50+(13*10)+Shift_UP_DN; 
    Tulis("T12", Right_Top, pos_x+2, pos_y, "Candle", 10, NamaFont, Info_Color);
    
    pos_x=11+Shift_Left_Right; pos_y=50+(13*11)+Shift_UP_DN; NamaFont="Arial"; UkuranFont=8; 
    Tulis("T13", Right_Top, pos_x, pos_y, "by ServerUang", UkuranFont, NamaFont, Gray);


    //*******************************************************************************
    
    //----------- Awal bagian menampilkan Informasi ---------------------------------
    NamaFont="Arial"; UkuranFont=10;
    jarak_baris = 13;
    
    //--- Informasi Highest ---
    d_A=iHigh(NULL,1440,0); teks=DoubleToStr(d_A, Digits);
    if (d_A>High_Lama) {WarnaTeks=Pips_Up_Color; High_Lama=d_A;}
       else {WarnaTeks=Info_Color;}
    pos_x=95+Shift_Left_Right; pos_y=50+Shift_UP_DN; //78
    Tulis("T32", Right_Top, pos_x, pos_y, "Hi", 10, NamaFont, Info_Color);
    Tulis("T33", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, Pips_Up_Color);
    
    //--- Informasi Lowest ---
    d_B=iLow(NULL,1440,0); teks=DoubleToStr(d_B, Digits);
    if (d_B<Low_Lama) {WarnaTeks=Pips_Dn_Color; Low_Lama=d_B;}
       else {WarnaTeks=Info_Color;}
    pos_x=93+Shift_Left_Right; pos_y=pos_y+13; //81
    Tulis("T34", Right_Top, pos_x, pos_y, "Lo", 10, NamaFont, Info_Color);
    Tulis("T35", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, Pips_Dn_Color);
    
    //--- Informasi Hi to Lo ---
    teks=DoubleToStr((d_A - d_B)/Point,0);
    pos_x=77+Shift_Left_Right; pos_y=pos_y+13; //77
    Tulis("T36", Right_Top, pos_x, pos_y, "Hi-Lo", 10, NamaFont, Info_Color);
    Tulis("T37", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, Hi_Low_Color);
    
    //--- Informasi Daily Av ---
    R1=0; R5=0; R10=0; R20=0; RAvg=0; i=0;
    R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
    for(i=1;i<=5;i++)   
        R5  = R5  + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
    for(i=1;i<=10;i++)
        R10 = R10 + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
    for(i=1;i<=20;i++)
        R20 = R20 + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

    R5 = R5/5;
    R10 = R10/10;
    R20 = R20/20;
    RAvg  =  (R1+R5+R10+R20)/4;    
   
    Teks_ReRata = (DoubleToStr(RAvg,Digits-4));
    Teks_Rerata_Kemarin = (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;

    if (Teks_ReRata > Teks_Rerata_Kemarin) {warna_ReRata = Daily_Av_Up_Color;}
       else {warna_ReRata = Daily_Av_Dn_Color;}
       
    pos_x=60+Shift_Left_Right; pos_y=pos_y+13; //75
    Tulis("T38", Right_Top, pos_x, pos_y, "Daily Av", 10, NamaFont, Info_Color);
    Tulis("T39", Right_Top, 10+Shift_Left_Right, pos_y, Teks_ReRata, UkuranFont, NamaFont, warna_ReRata);
    
    //--- Informasi Distance from Highest ---
    d_C=iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0); //chek harga sekarang
    teks=DoubleToStr((d_C - d_A)/Point,0); //hitung jarak dengan highest
    if (d_C > d_A) {WarnaTeks=Pips_Up_Color ;}
       else {WarnaTeks=Pips_Dn_Color ;}
    
    pos_x=79+Shift_Left_Right; pos_y=pos_y+13; //75
    Tulis("T40", Right_Top, pos_x, pos_y, "to-Hi", 10, NamaFont, Info_Color); //Info_Color
    Tulis("T41", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, WarnaTeks);
    
    //--- Informasi Distance from Lowest ---
    if (d_C > d_B) {WarnaTeks=Pips_Up_Color ;}
       else {WarnaTeks=Pips_Dn_Color ;}
    teks=DoubleToStr((d_C - d_B)/Point,0);
    pos_x=77+Shift_Left_Right; pos_y=pos_y+13; //75
    Tulis("T42", Right_Top, pos_x, pos_y, "to-Lo", 10, NamaFont, Info_Color);//Info_Color
    Tulis("T43", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, WarnaTeks);
    
    //--- Informasi from Pips to Open ---
    d_A = iOpen(NULL,1440,0);
    d_B = iClose(NULL,1440,0);
    if (d_B >= d_A) {WarnaTeks=Pips_Up_Color ;}
       else {WarnaTeks=Pips_Dn_Color ;}
    teks=DoubleToStr((d_B-d_A)/Point,0);
    pos_x=60+Shift_Left_Right; pos_y=pos_y+13; //75
    Tulis("T44", Right_Top, pos_x, pos_y, "to-Open", 10, NamaFont, Info_Color);//Info_Color
    Tulis("T45", Right_Top, 10+Shift_Left_Right, pos_y, teks, UkuranFont, NamaFont, WarnaTeks);
    
    //--- Informasi Spread ---
    d_C = (Ask - Bid)/Point;   teks = (DoubleToStr(d_C,Digits-4));
    Tulis("T46", Right_Top, 10+Shift_Left_Right, 50+(13*7)+Shift_UP_DN, teks, UkuranFont, NamaFont, Gold);
    
    //--- Informasi Time for Next Candle ---
    d_B = (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
    d_A = d_B/60;
    d_B = (d_A-MathFloor(d_A))*60;
    d_A = MathFloor(d_A);
    teks = DoubleToStr(d_A,0) + ":" + DoubleToStr(d_B,0);
    Tulis("T47", Right_Top, 10+Shift_Left_Right, 50+(13*10)+Shift_UP_DN, teks, UkuranFont, NamaFont, White);

   
       // --- Awal Menghitung Buy Swap ---------------------------------------------
       NamaFont="Arial"; UkuranFont=10;
       d_A     = NormalizeDouble(MarketInfo(Symbol(),18),2);
       teks = DoubleToStr(d_A,2);
       pos_x=48+Shift_Left_Right; pos_y=50+(13*8)+Shift_UP_DN;
       
       Tulis("T48", Right_Top, pos_x, pos_y, "Buy Swap", 10, NamaFont, Info_Color);
       pos_x=11+Shift_Left_Right; 
       Tulis("T49", Right_Top, pos_x, pos_y, teks, UkuranFont, NamaFont, Pips_Up_Color);
       // --- Akhir Menghitung Buy Swap --------------------------------------------
     
       // --- Awal Menghitung Sell Swap --------------------------------------------
       d_B     = NormalizeDouble(MarketInfo(Symbol(),19),2);
       teks = DoubleToStr(d_B,2);
       pos_x=49+Shift_Left_Right; pos_y=50+(13*9)+Shift_UP_DN;
       Tulis("T50", Right_Top, pos_x, pos_y, "Sell Swap", 10, NamaFont, Info_Color);
       pos_x=11+Shift_Left_Right;
       Tulis("T51", Right_Top, pos_x, pos_y, teks, UkuranFont, NamaFont, Pips_Dn_Color);
       // --- Akhir Menghitung Sell Swap -------------------------------------------  
    
    //----------- Akhir bagian menampilkan Informasi ---------------------------------
    
    //*******************************************************************************
    // --- Menampilkan Nama Pair Saat Ini -----------------------------
         Tulis("T98", 1, 10+Shift_Left_Right, 5+Shift_UP_DN, Symbol(), 12, "Arial Bold", White);
    // --- Akhir Menampilkan Nama Pair dan TimeFrame Saat Ini -------
    
    //---------- Awal  Menampilkan Harga Pair ---------------------------------------
    nilai = iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);
    teks  = DoubleToStr(nilai,Digits);
    //WarnaHarga ditentukan dari sinyal BuySeLL TF 15 menit 
    Tulis("T99", Right_Top, 10+Shift_Left_Right, 20+Shift_UP_DN, teks, 20, "Arial", cOlr_m15);
    //---------- Akhir Menampilkan Harga Pair ---------------------------------------
    
 
//----
   return(0);
  }

//+------------------------------------------------------------------+
// Prosedur Tulis
void Tulis(string LBL, double sebelah, int pos_x, int pos_y, string teks, int ukuran_huruf, string nama_huruf, color warna=CLR_NONE)
     {
       //Label_Teks = LBL;
       ObjectCreate(LBL, OBJ_LABEL, 0, 0, 0);
       ObjectSetText(LBL,teks, ukuran_huruf, nama_huruf, warna);
       ObjectSet(LBL, OBJPROP_CORNER, sebelah);
       ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
       ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
     }
     
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_HLINE);
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_LABEL);
//----
   return(0);
  }